/*
 * Copyright 2018 NXP
 * All rights reserved.
 *
 * SPDX-License-Identifier: BSD-3-Clause
 */

#ifndef _PERIPHERALS_H_
#define _PERIPHERALS_H_

/***********************************************************************************************************************
 * Included files
 **********************************************************************************************************************/
#include "fsl_common.h"
#include "fsl_clock.h"
#include "fsl_tpm.h"
#include "fsl_i2c.h"

#if defined(__cplusplus)
extern "C" {
#endif /* __cplusplus */

/***********************************************************************************************************************
 * Definitions
 **********************************************************************************************************************/
/* Definitions for BOARD_InitPeripherals functional group */
/* Definition of peripheral ID */
#define BOARD_TIMER_PERIPHERAL TPM2
/* Definition of the clock source frequency */
#define BOARD_TIMER_CLOCK_SOURCE 48000000UL
/* TIMER interrupt vector ID (number). */
#define BOARD_TIMER_IRQN TPM2_IRQn
/* TIMER interrupt handler identifier. */
#define BOARD_TIMER_IRQHANDLER TPM2_IRQHandler
#define BOARD_TPM_IRQ_HANDLER_FUNC TPM2_IRQHandler
/* BOARD_InitPeripherals defines for I2C1 */
/* Definition of peripheral ID */
#define BOARD_ACCEL_I2C_PERIPHERAL I2C1
/* Definition of the clock source */
#define BOARD_ACCEL_I2C_CLOCK_SOURCE I2C1_CLK_SRC
/* Definition of the clock source frequency */
#define BOARD_ACCEL_I2C_CLK_FREQ CLOCK_GetFreq(BOARD_ACCEL_I2C_CLOCK_SOURCE)

/***********************************************************************************************************************
 * Global variables
 **********************************************************************************************************************/
extern const tpm_config_t BOARD_TIMER_config;
extern const i2c_master_config_t BOARD_ACCEL_I2C_config;

/***********************************************************************************************************************
 * Initialization functions
 **********************************************************************************************************************/
void BOARD_InitPeripherals(void);

/***********************************************************************************************************************
 * BOARD_InitBootPeripherals function
 **********************************************************************************************************************/
void BOARD_InitBootPeripherals(void);

#if defined(__cplusplus)
}
#endif

#endif /* _PERIPHERALS_H_ */
